#!/bin/bash
Basepath=$(cd `dirname $0`; pwd)

KernelVersion=`/bin/uname -r`
TargetKVersion="4.15.0-30-generic"

if [ ${KernelVersion} == ${TargetKVersion} ]; then
    mkdir -p /appex/etc /appex/bin
    if [ ! -f /appex/bin/acce-3.11.36.6-\[Debian_9.3_4.9.0-4-amd64\] ]; then
        cp ${Basepath}/lotServer/acce-3.11.36.6-\[Debian_9.3_4.9.0-4-amd64\] /appex/bin/
    fi
    chmod +x /appex/bin/acce-3.11.36.6-\[Debian_9.3_4.9.0-4-amd64\]
    curl -o /appex/etc/apx.lic `${Basepath}/lotServer/lotCheck.sh | grep Serial | cut -f 3 | awk '{S=$1;N="https://lotserver.tty1.dev/20991231/";C=(N""S);print C}'`
    bash $Basepath/lotServer/install.sh
else
    echo "The kernel version does not match!"
    echo "The current kernel is ${KernelVersion}, the target version is ${TargetKVersion}"
    echo "Tring to replace the kernel, it requires a reboot and may cause instablility..."
    read -r -p "Are you sure to do that? [Y/n] " input

    case $input in
        [yY][eE][sS]|[yY])
	    echo "Start replacing kernel..."
	    ;;
        [nN][oO]|[nN])
	    echo "Stop replacing kernel."
            exit 1
            ;;
        *)
	    echo "Other input, quit!"
	    exit 1
	    ;;
    esac
    apt-get purge linux-image* linux-headers*
    apt-get install -y linux-image-4.15.0-30-generic linux-headers-4.15.0-30-generic && update-grub && reboot
fi
